#version 450

precision highp float;

layout(location = 0) out vec4 fragColor;
layout(location = 0) in vec4 color;

layout(set = 0, binding = 0, std140) uniform Uniforms
{
    uniform mat4 VP;
    uniform vec4 screenDimension;
};

layout(set = 0, binding = 1, std140) buffer PixelBuffer
{
  vec4 pixels[];
} pixelBuffer;

void main()
{
    float fx = color.x;
    float fy = color.y;

    int pixX = int(fx * screenDimension.x);
    int pixY = int(fy * screenDimension.y);

    int pixelIndex = pixX + pixY * int(screenDimension.x);
    vec4 pixelColor = pixelBuffer.pixels[pixelIndex];

    fragColor = pixelColor;
}
