const path = require('path');
const HtmlWebpackPlugin = require('html-webpack-plugin');
const CopyPlugin = require("copy-webpack-plugin");

module.exports =
{
  mode: 'development',
  entry:
  {
    app: './src/index.js',
  },
  devtool: 'inline-source-map',
  devServer: {
    contentBase: './dist',
  },
    plugins: [
       new HtmlWebpackPlugin({
         title: 'Output Management',
       }),
       new CopyPlugin({
          patterns: [
              { from: "src/assets/bunny1000.obj", to: "assets" },
      ]}),
      new HtmlWebpackPlugin({
        template: 'src/index.html',
      }),
     ], 
  output:
  {
    filename: '[name].bundle.js',
    path: path.resolve(__dirname, 'dist'),
  },
  module: {
    rules: [
      {
        test: /\.css$/i,
        use: ['style-loader', 'css-loader'],
      },
      {
        test: /\.(png|svg|jpg|jpeg|gif)$/i,
        type: 'asset/resource',
      },
      {
        test: /\.(woff|woff2|eot|ttf|otf)$/i,
        type: 'asset/resource',
      },
      {
        test: /\.(glsl|frag|vert)$/,
        use: ['glslify-import-loader', 'raw-loader', 'glslify-loader']
      },
      {
        test: /\.(obj)$/,
        use: [ 'webpack-obj-loader' ]
      },
    ],
  },

};
